total_R=20;
select_N=[10,20,50,100,200,500,1000];
total_N=length(select_N);

nnz_NP_t=zeros(total_N,total_R);
nnz_NP_n=zeros(total_N,total_R);
nnz_NP_b=zeros(total_N,total_R);
nnz_MSNP_b=zeros(total_N,total_R);
nnz_NPL_b=zeros(total_N,total_R);
nnz_NPF_b=zeros(total_N,total_R);

for i=1:total_N
    for j=1:20
        ki=select_N(i);
        [loglik,nnz]=extractlogliknr(ki,j,'../bexp/gmm/','_bexp.den');
        nnz_NP_b(i,j)=nnz(4);
    end
end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
        [loglik,nnz]=extractlogliknr(ki,j,'../texp/','_texp.den');
        nnz_NP_t(i,j)=nnz(4);
    end
end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
        [loglik,nnz]=extractlogliknr(ki,j,'../nexp/','_rexp.den');
        nnz_NP_n(i,j)=nnz(4);
    end
end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_msnp/','_bexp.den');
        nnz_MSNP_b(i,j)=nnz(5);
    end
end

% for i=1:total_N
%     for j=1:20
%         ki=select_N(i);
%         [loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_fixd/','_bexp.den');
%         nnz_NPF_b(i,j)=nnz(4);
%     end
% end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_logd/','_bexp.den');
        nnz_NPL_b(i,j)=nnz(4);
    end
end

color1=[85,107,47]./255.0;
color2=[213,159,15]./255.0;

h1=figure(1);
hold on;
%minll=min(min([ll_KDE;ll_GMM;ll_NP;ll_MSNP]))-500;
%maxll=max(max(ll_true))+500;

%Log-scale

% x=log([10:10:90,100:100:900]);
% 
% 
% boxplot(log(nnz_NP_t'+1),'symbol','','colors','k','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg1=plot(x,median(log(nnz_NP_t'+1)),'k--','LineWidth',1.5);
% 
% boxplot(log(nnz_NP_n'+1),'symbol','','colors','b','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg2=plot(x,median(log(nnz_NP_n'+1)),'b--','LineWidth',1.5);
% 
% boxplot(log(nnz_NP_b'+1),'symbol','','colors','r','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg3=plot(x,median(log(nnz_NP_b'+1)),'r--','LineWidth',1.5);
% 
% boxplot(log(nnz_MSNP_b'+1),'symbol','','colors','m','widths',3,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg4=plot(x,median(log(nnz_MSNP_b'+1)),'m--','LineWidth',1.5);
% 
% boxplot(log(nnz_NPL_b'+1),'symbol','','colors',color1,'widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg5=plot(x,median(log(nnz_NPL_b'+1)),'--','LineWidth',1.5,'color',color1);
% 
% boxplot(log(nnz_NPF_b'+1),'symbol','','colors',color2,'widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg6=plot(x,median(log(nnz_NPF_b'+1)),'--','LineWidth',1.5,'color',color2);
% 
% set(gca,'XTick',[log(10),log(100),log(500),log(1000)]);
% set(gca,'XTickLabel',{'10','100','500','1000'},'FontSize',14);
% 
% axis([log(8),log(1050),0,log(1000)]);
% 
% xlabel('log(n)','FontSize',20);
% 
% ylabel('log(No. non-zeros)','FontSize',20);

% Non-log-scale

x=log(select_N);

%boxplot(nnz_NP_t','symbol','','colors','k','widths',30,'position',x); 
set(gca,'XTickLabel',{' '});
hleg1=plot(x,mean(nnz_NP_t')./select_N,'k--','LineWidth',3);

%boxplot(nnz_NP_n','symbol','','colors','b','widths',30,'position',x); 
set(gca,'XTickLabel',{' '});
hleg2=plot(x,mean(nnz_NP_n')./select_N,'b--','LineWidth',1.5);

%boxplot(nnz_NP_b','symbol','','colors','r','widths',30,'position',x); 
set(gca,'XTickLabel',{' '});
hleg3=plot(x,mean(nnz_NP_b')./select_N,'r--','LineWidth',2);

%boxplot(nnz_MSNP_b','symbol','','colors','m','widths',30,'position',x); 
set(gca,'XTickLabel',{' '});
hleg4=plot(x,mean(nnz_MSNP_b')./select_N,'m--','LineWidth',2);

%boxplot(nnz_NPL_b','symbol','','colors',color1,'widths',30,'position',x); 
set(gca,'XTickLabel',{' '});
hleg5=plot(x,mean(nnz_NPL_b')./select_N,'--','LineWidth',2,'color',color1);

%boxplot(nnz_NPF_b','symbol','','colors',color2,'widths',30,'position',x); 
%set(gca,'XTickLabel',{' '});
%hleg6=plot(x,mean(nnz_NPF_b'),'--','LineWidth',1.5,'color',color2);

set(gca,'XTick',log(select_N));
set(gca,'XTickLabel',{'10','20','50','100','200','500','1000'},'FontSize',14);

axis([log(8),log(1050),0,0.9]);

xlabel('number of training points (n)','FontSize',20);

ylabel('proportion of non-zeros','FontSize',20);


%title('Number of non-zero augmented parameters','FontSize',20);    

%lh=legend([hleg1,hleg2,hleg3,hleg4,hleg5,hleg6],'True','KDE','GMM','NPG','CNPG','NPG-lgN','NPG-c');
lh=legend([hleg1,hleg2,hleg3,hleg4,hleg5],'NPG-t','NPG-n','NPG','CNPG','NPG-lgN');
set(lh,'Location','SouthWest','FontSize',14);

hold off;
%save2pdf('nnzplot.pdf',h1,300);

saveas(h1,'nnzplot.fig');