function [ll,densitys]=testopdatan(n,r,inpath)

data_train=csvread([inpath,'opdata/','opdata_n',num2str(n),'_r',num2str(r),'_bexp.csv']);
data_test=csvread([inpath,'opdata/','opdata_testn',num2str(n),'_r',num2str(r),'_bexp.csv']);

M=emgaussian(data_train,2);
ll=0;
for i=1:size(data_test,1)
    ll=ll+log(M.p(1)*normpdf(data_test(i),M.mu(1,:),M.Sigma(:,:,1))+M.p(2)*normpdf(data_test(i),M.mu(2,:),M.Sigma(:,:,2)));
end

densitys=dlmread([inpath,'wsg_n',num2str(n),'_r',num2str(r),'_bexp.den']);
for i=1:size(densitys,1)
    densitys(i,4)=M.p(1)*normpdf(densitys(i,1),M.mu(1,:),M.Sigma(:,:,1))+M.p(2)*normpdf(densitys(i,1),M.mu(2,:),M.Sigma(:,:,2));
end

dlmwrite([inpath,'gmm/wsg_n',num2str(n),'_r',num2str(r),'_bexp.den'],densitys,'delimiter',' ','precision',6);

loglikstxt=dlmread([inpath,'loglik_n',num2str(n),'_r',num2str(r),'_bexp.den']);
loglikstxt(3)=ll;

dlmwrite([inpath,'gmm/loglik_n',num2str(n),'_r',num2str(r),'_bexp.den'],loglikstxt,'precision',6);

