total_R=20;
select_N=[10,20,50,100,200,500,1000];
total_N=length(select_N);

ll_true=zeros(total_N,total_R);
ll_KDE=zeros(total_N,total_R);
ll_GMM=zeros(total_N,total_R);
ll_NP=zeros(total_N,total_R);
ll_MSNP=zeros(total_N,total_R);
ll_NPF=zeros(total_N,total_R);
ll_NPL=zeros(total_N,total_R);

for i=1:total_N
    for j=1:20
        ki=select_N(i);
        [loglik,nnz]=extractlogliknr(ki,j,'../bexp/gmm/','_bexp.den');
        ll_true(i,j)=loglik(1);
	ll_GMM(i,j)=loglik(3);
	ll_NP(i,j)=loglik(4);
    end
end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
	    [loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_msnp/','_bexp.den');
        %[loglik,nnz]=extractlogliknr(ki,j,'../bexp/','_bexp.den');
	    ll_MSNP(i,j)=loglik(5);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_kk/','_bexp.den');
    %[loglik,nnz]=extractlogliknr(ki,j,'../bexp/','_bexp.den');
	ll_KDE(i,j)=loglik(2);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end
%ll_MSNP(1:9,:)=repmat(ll_MSNP(10,:),9,1);
% 
% for i=1:total_N
%     for j=1:20
%         ki=select_N(i);
% 	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_fixd/','_bexp.den');
% 	ll_NPF(i,j)=loglik(4);
%         %nnz_NP(i,j)=nnz(4);
%         %nnz_MSNP(i,j)=nnz(5);
% 
%     end
% end

for i=1:total_N
    for j=1:20
        ki=select_N(i);
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/bexp_logd/','_bexp.den');
	ll_NPL(i,j)=loglik(4);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end
% 
% color1=[85,107,47]./255.0;
% color2=[213,159,15]./255.0;
% 
% h1=figure(1);
% hold on;
% minll=min(min([ll_KDE;ll_GMM;ll_NP;ll_MSNP]))-500;
% maxll=max(max(ll_true))+500;
% x=[log(10),log(20),log(50),log(100),log(200),log(500)];%,log(1000)];
% 
% %boxplot(ll_true','symbol','','colors','k','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg1=plot(x,mean(ll_true'),'k-','LineWidth',2);
% 
% %boxplot(ll_KDE','symbol','','colors','b','widths',0.1,'position',x);
% set(gca,'XTickLabel',{' '}); 
% hleg2=plot(x,mean(ll_KDE'),'b--','LineWidth',2.2);
% 
% %boxplot(ll_GMM','symbol','','colors','k','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg3=plot(x,mean(ll_GMM'),'k--','LineWidth',1.5);
% 
% %boxplot(ll_NP','symbol','','colors','r','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg4=plot(x,mean(ll_NP'),'r--','LineWidth',3);
% 
% %boxplot(ll_MSNP','symbol','','colors','m','widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg5=plot(x,mean(ll_MSNP'),'m--','LineWidth',3);
% 
% %boxplot(ll_NPL','symbol','','colors',color1,'widths',0.1,'position',x); 
% set(gca,'XTickLabel',{' '});
% hleg6=plot(x,mean(ll_NPL'),'--','LineWidth',3,'color',color1);
% 
% %boxplot(ll_NPF','symbol','','colors',color2,'widths',0.1,'position',x); 
% %set(gca,'XTickLabel',{' '});
% %hleg7=plot(x,mean(ll_NPF'),'--','LineWidth',3,'color',color2);
% 
% set(gca,'XTick',log([10,20,50,100,200,500,1000]));
% set(gca,'XTickLabel',{'10','20','50','100','200','500','1000'},'FontSize',14);
% 
% axis([log(8),log(1050),-240000,maxll]);
% 
% xlabel('log(n)','FontSize',20);
% 
% ylabel('Out-of-sample log-likelihood','FontSize',20);
% 
% %title('Fitting Mixed Normal','FontSize',20);    
% 
% lh=legend([hleg1,hleg2,hleg3,hleg4,hleg5,hleg6],'True','KDE','GMM','NPG','CNPG','NPG-lgN');
% %lh=legend([hleg1,hleg2,hleg3,hleg4,hleg6,hleg7],'True','KDE','GMM','NPG','NPG-lgN','NPG-c');
% set(lh,'Location','SouthEast','FontSize',14);
% 
% hold off;
% %save2pdf('ll_bexp.pdf',h1,300);
% saveas(h1,'ll_bexp.fig');
% 

sigt=zeros(4,total_N);
for i=1:total_N,
    sigt(1,i)=ttest2(ll_NP(i,:),ll_KDE(i,:));
    sigt(2,i)=ttest2(ll_NP(i,:),ll_GMM(i,:));
    sigt(3,i)=ttest2(ll_NP(i,:),ll_MSNP(i,:));    
    sigt(4,i)=ttest2(ll_NP(i,:),ll_NPL(i,:));
end

