total_N=19;
total_R=20;

ll_true=zeros(total_N,total_R);
ll_KDE=zeros(total_N,total_R);
ll_GMM=zeros(total_N,total_R);
ll_NP=zeros(total_N,total_R);
ll_MSNP=zeros(total_N,total_R);

for i=1:9
    for j=1:20
        ki=i*10;
	[loglik,nnz]=extractlogliknr(ki,j,'../texp/fitt/','_texp.den');
	ll_true(i,j)=loglik(1);
	ll_KDE(i,j)=loglik(2);
	ll_GMM(i,j)=loglik(5);
	ll_NP(i,j)=loglik(4);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end

for i=1:10
    for j=1:20
        ki=i*100;
	[loglik,nnz]=extractlogliknr(ki,j,'../texp/fitt/','_texp.den');
	ll_true(i+9,j)=loglik(1);
	ll_KDE(i+9,j)=loglik(2);
	ll_GMM(i+9,j)=loglik(5);
	ll_NP(i+9,j)=loglik(4);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end

for i=1:9
    for j=1:20
        ki=i*10;
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/texp_msnp/','_texp.den');
	ll_MSNP(i,j)=loglik(5);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end

for i=1:10
    for j=1:20
        ki=i*100;
	[loglik,nnz]=extractlogliknr(ki,j,'/scratch/lustreA/y/yuanl/nexp_kde_CV/texp_msnp/','_texp.den');
	ll_MSNP(i+9,j)=loglik(5);
        %nnz_NP(i,j)=nnz(4);
        %nnz_MSNP(i,j)=nnz(5);

    end
end

h1=figure(1);

hold on;
minll=-192000;
maxll=max(max(ll_true))+5000;
x=[log(10:10:90),log(100:100:1000)];
labels={'100',' ',' ',' ','500',' ',' ',' ',' ','1000'};

boxplot(ll_true','symbol','','colors','k','widths',0.1,'position',x); 
set(gca,'XTickLabel',{' '});
hleg1=plot(x,median(ll_true'),'k-','LineWidth',2);

boxplot(ll_KDE','symbol','','colors','b','widths',0.1,'position',x);
set(gca,'XTickLabel',{' '}); 
hleg2=plot(x,median(ll_KDE'),'b--','LineWidth',2.2);

boxplot(ll_GMM','symbol','','colors','k','widths',0.1,'position',x); 
set(gca,'XTickLabel',{' '});
hleg3=plot(x,median(ll_GMM'),'k--','LineWidth',1.5);

boxplot(ll_NP','symbol','','colors','r','widths',0.1,'position',x); 
set(gca,'XTickLabel',{' '});
hleg4=plot(x,median(ll_NP'),'r--','LineWidth',3);

boxplot(ll_MSNP','symbol','','colors','m','widths',0.1,'position',x); 
set(gca,'XTickLabel',{' '});
hleg5=plot(x,median(ll_MSNP'),'m--','LineWidth',3);

set(gca,'XTick',log([10,20,50,100,500,1000]));
set(gca,'XTickLabel',{'10','20','50','100','500','1000'},'FontSize',14);


lh=legend([hleg1,hleg2,hleg3,hleg4,hleg5],'True','KDE','t-fit','NPG','CNPG');
set(lh,'Location','SouthEast','FontSize',14);

axis([log(8),log(1050),minll,maxll]);

xlabel('log(n)','FontSize',20);

ylabel('Out-of-sample log-likelihood','FontSize',20);

title('Fitting t Distribution with df=6','FontSize',20);

hold off;
%save2pdf('ll_texp.pdf',h1,300);


